###################################################
### chunk number 1: setup
###################################################
#line 42 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
save.files <- FALSE # set TRUE to save some of the generated objects
#.libPaths(c(.libPaths(), normalizePath(paste('/home/renaud/hetero/build/lib', sep=''))))	
options(width=80)
options(prompt=' ')
options(continue='  ')


###################################################
### chunk number 2: install_cmd eval=FALSE
###################################################
## #line 86 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
## # install annotation package from Bioconductor
## source("http://bioconductor.org/biocLite.R")
## biocLite("hgu133plus2.db")
## # install NMFged
## install.packages('NMFged', repos=c("@CRAN@", "http://web.cbio.uct.ac.za/~renaud/paper/meegid-deconvolution"))


###################################################
### chunk number 3: load_libs
###################################################
#line 97 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
	library(NMFged)


###################################################
### chunk number 4: parameters
###################################################
#line 101 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# compute p-values on log2 transformed data?
log2.transform <- TRUE
# p-value threshold (upper bound)
p.threshold <- 0.05
# fold-change threshold (lower bound in linear or log2 unit)
f.threshold <- 1.5
# maximum number of markers per cell-type
max.markers <- 300
# use equal variance in t-test
var.equal <- TRUE


###################################################
### chunk number 5: source_files
###################################################
#line 114 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"

if( save.files ){
	rversion <- paste(R.version$major, R.version$minor, sep='.')
	
	savedir <- paste('p', p.threshold, 'f', f.threshold, sep='_')
	if( log2.transform )
		savedir <- paste(savedir, 'log2', sep='_')
	if( var.equal )
		savedir <- paste(savedir, 'Veq', sep='_') 
	if( !file.exists(savedir) )
		dir.create(savedir)
	
	l.savedir <- gsub("_", "\\\\_", savedir, fixed=TRUE)
	
	datafile <- function(dataset, type, prefix=NULL){
		if( !is.null(prefix) )
			type <- paste(type, prefix, sep='_')
		
		file.path(savedir, paste(paste(dataset, type, sep='_'), '.RData', sep=''))
	}
	
	# create sub-directories
	if( !file.exists('data') )
		dir.create('data')	
}
if( !file.exists('figures') )
	dir.create('figures')


###################################################
### chunk number 6: geo_command_GSE11058 eval=FALSE
###################################################
## #line 149 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
## library(GEOquery)
## ## LOAD ORIGINAL DATA FROM GEO (ACCESSION: GSE11058)
## GSE11058 <- getGEO('GSE11058')[[1]]
## annotation(GSE11058) <- 'hgu133plus2.db'


###################################################
### chunk number 7: load_GSE11058
###################################################
#line 156 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
d <- data()
## DO THE ACTUAL LOAD
if( 'GSE11058' %in% d$results[,'Item'] ){
	data(GSE11058)
}else{
	local.datafile <- 'data/GSE11058'
	## LOAD ORIGINAL DATA FROM GEO (ACCESSION: GSE11058)
	library(GEOquery)
	GSE11058 <- getGEO('GSE11058')[[1]]
	annotation(GSE11058) <- 'hgu133plus2.db'
	if( save.files )
		save(GSE11058, file=local.datafile)
}
rm(d)


###################################################
### chunk number 8: show_data
###################################################
#line 174 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
GSE11058


###################################################
### chunk number 9: remove_affy_controls
###################################################
#line 181 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
library(genefilter)
# remove affy control porbesets, i.e. those with IDs starting with "AFFX"
GSE11058 <- featureFilter(GSE11058, require.entrez=FALSE, remove.dupEntrez=FALSE)
dim(GSE11058)
##


###################################################
### chunk number 10: full_model
###################################################
#line 193 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# build the "true" NMF model
model <- nmfModel(W=GSE11058.basis(GSE11058), H=GSE11058.coef(GSE11058))
model 
##


###################################################
### chunk number 11: save_model
###################################################
#line 200 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
if( save.files )
	save(model, file=datafile('GSE11058', 'all', 'model'))


###################################################
### chunk number 12: build_curated_dataset
###################################################
#line 211 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
## CURATED DATASET
# load the probeset IDs
data(curated.probes)
length(curated.probes)
# subset the original dataset
curated.dataset <- GSE11058[curated.probes, ]
dim(curated.dataset)


###################################################
### chunk number 13: save_curated_dataset
###################################################
#line 221 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# save the data
if( save.files )
	save(curated.dataset, file='GSE11058.curated.RData')


###################################################
### chunk number 14: curated_model
###################################################
#line 229 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
curated.model <- model[curated.probes,]
curated.model 


###################################################
### chunk number 15: save_curated_model
###################################################
#line 234 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
	if( save.files )
		save(curated.model, file=datafile('curated', 'all', 'model'))


###################################################
### chunk number 16: build_full_dataset
###################################################
#line 243 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
full.dataset <- featureFilter(GSE11058, require.entrez=TRUE, remove.dupEntrez=FALSE)
dim(full.dataset)
##


###################################################
### chunk number 17: save_full_dataset
###################################################
#line 249 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# save the data
if( save.files )
	save(full.dataset, file=paste('GSE11058.full.', rversion, '.RData', sep=''))


###################################################
### chunk number 18: full_model
###################################################
#line 257 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
full.model <- model[featureNames(full.dataset),]
full.model 


###################################################
### chunk number 19: save_full_model
###################################################
#line 262 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
	if( save.files )
		save(full.model, file=datafile('full', 'all', 'model'))


###################################################
### chunk number 20: parameters_show
###################################################
#line 273 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
#line 101 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw#from line#273#"
# compute p-values on log2 transformed data?
log2.transform <- TRUE
# p-value threshold (upper bound)
p.threshold <- 0.05
# fold-change threshold (lower bound in linear or log2 unit)
f.threshold <- 1.5
# maximum number of markers per cell-type
max.markers <- 300
# use equal variance in t-test
var.equal <- TRUE
#line 274 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"


###################################################
### chunk number 21: statfile
###################################################
#line 278 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
statfile <- 'probeset.stats'
if( log2.transform )
	statfile <- paste(statfile, 'log2', sep='.')
if( var.equal )
	statfile <- paste(statfile, 'Veq', sep='.') 


###################################################
### chunk number 22: pure_samples
###################################################
#line 289 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
## EXTRACT MARKERS
# limit to the pure cell-types, i.e. the 12 first ones
pure.idx <- 1:12
pure <- GSE11058[, pure.idx]
# the cell-types are stored in covariate 'characteristics_ch1'
types <- factor(pure$characteristics_ch1, levels=unique(pure$characteristics_ch1))
types


###################################################
### chunk number 23: extract_markers eval=FALSE
###################################################
## #line 302 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
## 
## # compute discriminative power of each probesets
## stats <- extractMarkers(pure, types, log2.transform=log2.transform, var.equal=var.equal)
## # compute qvalues separately for each cell-type and add them to the stats
## library(qvalue)
## ct.all <- markerStatstoList(stats, types, NULL)
## qv <- lapply(ct.all, function(x){ q <- qvalue(x); q$qvalue })
## qv <- unlist(setNames(qv, NULL))
## stats <- cbind(stats, qvalue=qv[rownames(stats)])
## 
## head(stats)


###################################################
### chunk number 24: do_extract_markers
###################################################
#line 316 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"

d <- data()
lk <- c(statfile, paste('stats (', statfile, ')', sep=''))
if(  any(lk %in% d$results[,'Item']) ){
	data(list=list(statfile))
}else{
	# compute discriminative power of each probesets
	stats <- extractMarkers(pure, types, log2.transform=log2.transform, var.equal=var.equal)
	# compute qvalues separately for each cell-type and add them to the stats
	library(qvalue)
	ct.all <- markerStatstoList(stats, types, NULL)
	qv <- lapply(ct.all, function(x){ q <- qvalue(x); q$qvalue })
	qv <- unlist(setNames(qv, NULL))
	stats <- cbind(stats, qvalue=qv[rownames(stats)])
	# save the computed stats
	if( save.files )
		save(stats, file=file.path('data', paste(statfile, 'rda', sep='.')))
}
rm(d)
head(stats)


###################################################
### chunk number 25: filter_probesets
###################################################
#line 342 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
	
# filter probesets on pvalue
sel <- stats[stats[,'pvalue2'] <= p.threshold, ]

# filter probesets on fold change
fold.var <- if( log2.transform ) 'diff2' else 'fold2'
if( !is.na(f.threshold) )
	sel <- sel[sel[,fold.var] >= f.threshold, ]


###################################################
### chunk number 26: generate_markerList
###################################################
#line 357 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# generate complete marker list
markers <- markerStatstoList(sel, types, 'pvalue2')
summary(markers)


###################################################
### chunk number 27: save_markers
###################################################
#line 363 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
if( save.files )
	save(markers, file=datafile('GSE11058', 'markers'))


###################################################
### chunk number 28: full_markers
###################################################
#line 372 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# only take the top markers
full.markers <- subset(markers, full.dataset, lim=max.markers)
summary(full.markers)
# check the qvalues
sapply(full.markers, function(x){ max(stats[names(x), 'qvalue']) })
# check the minimum mean fold change
sapply(full.markers, function(x){ min(stats[names(x), fold.var]) })


###################################################
### chunk number 29: save_markers_full
###################################################
#line 382 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# save the markers
if( save.files )
	save(full.markers, file=datafile('full', 'markers'))


###################################################
### chunk number 30: full_markers_plot
###################################################
#line 392 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# plot the markers
plotMarkers(full.markers, pure, types, cex=0.5)


###################################################
### chunk number 31: full_markers_hm
###################################################
#line 406 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# plot a heatmap of the pure samples (limit to the markers)
markermap(full.markers, full.dataset[, pure.idx], types, show_row=FALSE, limit=TRUE)


###################################################
### chunk number 32: curated_markers
###################################################
#line 419 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# filter the markers that are present in the curated dataset
curated.markers <- subset(markers, curated.dataset)
summary(curated.markers)
# check the minimum mean fold change
sapply(curated.markers, function(x){ min(stats[names(x), fold.var]) })


###################################################
### chunk number 33: save_markers_full
###################################################
#line 427 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# save the markers
if( save.files )
	save(curated.markers, file=datafile('curated', 'markers'))


###################################################
### chunk number 34: curated_markers_plot
###################################################
#line 434 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# plot the markers
plotMarkers(curated.markers, pure, types, cex=0.7)


###################################################
### chunk number 35: curated_markers_hm
###################################################
#line 445 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
# plot a heatmap of the curated pure samples (limit to the markers)
markermap(curated.markers, curated.dataset[, pure.idx], types, limit=TRUE, cex=0.5)


###################################################
### chunk number 36: curated_markers_hm_allprobes
###################################################
#line 455 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
markermap(curated.markers, curated.dataset[, pure.idx], types, show_row=FALSE)


###################################################
### chunk number 37: curated_model_hm
###################################################
#line 467 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
markermap(curated.markers, curated.model, show_row=FALSE)


###################################################
### chunk number 38: save_composite_data
###################################################
#line 477 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
if( save.files ){
	## SAVE FOR ANALYSIS
	NMFged:::newMix(full.dataset, full.markers, full.model, filename=datafile('full', 'all'))
	NMFged:::newMix(full.dataset, full.markers, full.model, filename=datafile('full', 'nopure'), subset=-pure.idx)
	NMFged:::newMix(curated.dataset, curated.markers, curated.model, filename=datafile('curated', 'all'))
	NMFged:::newMix(curated.dataset, curated.markers, curated.model, filename=datafile('curated', 'nopure'), subset=-pure.idx)
	##
}


###################################################
### chunk number 39: remove_pure
###################################################
#line 493 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
curated.dataset <- curated.dataset[, -(1:12)]
curated.dataset
curated.model <- curated.model[, -(1:12)]
curated.model


###################################################
### chunk number 40: sbrunet
###################################################
#line 519 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
set.seed(123456)
res0 <- nmf(curated.dataset, 4, 'Sbrunet', seed='rprop', nrun=10, .opt='v2')
# scale the mixture coefficients to get proportions
coef(res0) <- scoef(res0)


###################################################
### chunk number 41: sbrunet_show
###################################################
#line 528 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
res0


###################################################
### chunk number 42: sbrunet_reorder
###################################################
#line 536 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
res <- match.nmf(res0, curated.markers)


###################################################
### chunk number 43: sbrunet_plots
###################################################
#line 553 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
	opar <- par(no.readonly=TRUE)
	par(mfrow=c(1, 2))	
	profplot(curated.model, res, main="Method: Sbrunet")	
	basismarker(res, curated.markers, add=TRUE)	
	par(opar)


###################################################
### chunk number 44: Gbrunet1
###################################################
#line 572 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
set.seed(123456)
res <- nmf(curated.dataset, 4, 'Gbrunet', markers=subset(curated.markers, 1), seed='rprop', nrun=10, .opt='v2')
# scale the mixture coefficients to get proportions
coef(res) <- scoef(res)


###################################################
### chunk number 45: gbrunet_plots
###################################################
#line 585 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
	opar <- par(no.readonly=TRUE)
	par(mfrow=c(1, 2))	
	profplot(curated.model, res, main="Method: Gbrunet - 1 marker")	
	basismarker(res, curated.markers, add=TRUE)	
	par(opar)


###################################################
### chunk number 46: sessionInfo
###################################################
#line 597 "C:/Documents and Settings/Administrator/My Documents/Projects/NMF/NMFged/inst/doc/markers.Rnw"
toLatex(sessionInfo())


